=== debian/tests/control ===
Tests: cli
Depends: php5-cli

Tests: cgi
Depends: apache2, php5-cgi
Restrictions: needs-root

Tests: mod-php
Depends: libapache2-mod-php5
Restrictions: needs-root
